var jimiHelper = {
	backHome: {
		postMessage: (...arg) => {
			history.go(-2);
		}
	},
	location: {
		postMessage: (...arg) => {
			console.log(...arg);
		}
	},
	navigation: {
		postMessage: (...arg) => {
			console.log(...arg);
		}
	}
};

var jimiAndroid = (varName) => {
	switch (varName) {
		case 'back':
			return window._jimiHelper.backHome.postMessage();
			break;
		case 'location':
			return window._jimiHelper.location.postMessage();
			break;

		default:
			break;
	}
};

/**
 * 
 * @param {Object} obj 
 * @param {String|[String]} keys 
 * @param {*} val 
 */
function deepSet(obj, keys, val) {
	keys.split && (keys = keys.split('.'));
	var i = 0,
		l = keys.length,
		t = obj,
		x;
	for (; i < l; ++i) {
		x = t[keys[i]];
		t = t[keys[i]] =
			i === l - 1 ? val : x != null ? x : !!~keys[i + 1].indexOf('.') || !(+keys[i + 1] > -1) ? {} : [];
	}
}

window._jimiHelper = jimiHelper;
window._jimiAndroid = jimiAndroid;

function setBackHome() {
	console.error('@@ setBackHome');
	try {
		deepSet(window, 'webkit.messageHandlers.backHome', window._jimiHelper.backHome);
		deepSet(window, 'webkit.messageHandlers.location', window._jimiHelper.location);
		deepSet(window, 'webkit.messageHandlers.navigation', window._jimiHelper.navigation);
	} catch (e) {
		console.error(e);
	}

	try {
		window.android = {};
		window.android.jumpApp = window._jimiAndroid;
	} catch (e) {
		console.error(e);
	}
}

// start
setBackHome();
if (!window._jimiPostMsgTimmer) {
	window._jimiPostMsgTimmer = setInterval(() => {
		// udf == undefined
		const isiOS_udf = false;
		const isAPK_udf = false;
		try {
			isiOS_udf = 'object' != typeof window.webkit.messageHandlers.backHome;
			isAPK_udf = 'function' != typeof window.android.jumpApp;
		} catch (error) {}

		if (isiOS_udf || isAPK_udf) {
			setBackHome();

			console.log('setInterval');
		}
	}, 500);
}
